use anyhow::Result;
use serial_embedded_hal::{PortSettings, Serial};
use spidriver::SPIDriver;

use std::io;

fn main() -> Result<()> {
    let port = Serial::new(
        "/dev/ttyUSB0",
        &PortSettings {
            baud_rate: serial_embedded_hal::BaudRate::BaudOther(460800),
            char_size: serial_embedded_hal::CharSize::Bits8,
            parity: serial_embedded_hal::Parity::ParityNone,
            stop_bits: serial_embedded_hal::StopBits::Stop1,
            flow_control: serial_embedded_hal::FlowControl::FlowNone,
        },
    )?;

    let (tx, rx) = port.split();
    let mut spidriver = SPIDriver::new(tx, rx);
    loop {
        let mut input = String::new();
        io::stdin().read_line(&mut input)?;

        let mut data = input.into_bytes();
        spidriver.transfer(&mut data);
    }

    Ok(())
}
